#include <string>
#include <fstream>
#include "../include/WordUtils.h"
#include <iostream>
#include <algorithm>

map<string, map<string, int>> WordUtils::load_data(const char *path) {
    const char del[] = {' ', '.', ',', '!', '?', ';', ':', '(', ')', '\n', '\r', '\t'};

    vector<string> data = split_string(load_file(path), del);

    map<string, map<string, int>> word_frequencies = {};

    for (long unsigned int i = 0; i + 1 < data.size(); i++) {
        word_frequencies[data[i]][data[i+1]]++;
    }



    vector<pair<string, vector<string, int>>> test;



    return word_frequencies;
}

vector<string> WordUtils::predictNextWord(const string& input, const map<string, map<string, int>>& model, size_t count) {
    auto it = model.find(input);

    if (it == model.end()) return {"(no prediction)"};

    const map<string, int> nextWords = it->second;

    vector<pair<string, int>> sortedWords(nextWords.begin(), nextWords.end());
    
    // Sort by frequency (descending)
    sort(sortedWords.begin(), sortedWords.end(),[](const auto& a, const auto& b) {
        return a.second > b.second;
    });

    vector<string> results;

    // Take up to `count` most common words
    for (size_t i = 0; i < min(count, sortedWords.size()); ++i) {
        results.push_back(sortedWords[i].first);
    }

    return results;
}


vector<string> WordUtils::split_string(const string& input, const char *delimiters) {
    vector<string> data;

    size_t start = 0;
    size_t end = 0;

    // Create a string from the delimiters array
    string delimiter_string(delimiters);

    while ((end = input.find_first_of(delimiter_string, start)) != string::npos) {
        if (end > start) {
            data.push_back(input.substr(start, end - start));
        }

        start = end + 1;
    }

    // Add the last token, if any
    if (start < input.length()) {
        data.push_back(input.substr(start));
    }

    return data;
}

string WordUtils::load_file(const char *path) {
    ifstream file(path);
    string temp;
    string data;

    while (getline(file, temp)) {
        data += temp;
    }

    file.close();

    return data;
}

string WordUtils::extract_url(const string& input) {
    int first_line_end = input.find("\n");
    if (first_line_end == string::npos) return "";

    string first_line = input.substr(0, first_line_end);

    int method_end = first_line.find(' ');
    if (method_end == string::npos) return "";

    int path_end = first_line.find(' ', method_end + 1);
    if (path_end == string::npos) return "";

    return first_line.substr(method_end + 1, path_end - method_end - 1);
}